<?php

class Demo
{
	#请求方标识（由途鸟科技统一分配）[必填]
	public $partner_id = 'P20180813092424605';
	#请求方加密数据 私有key
	public $private_key = 'ageKz5RTjV8o';
	#请求方加密数据 私有iv
	public $private_iv = '2034501905940870';
	#请求方解密数据 公共key
	public $public_key = 'tuniaokeji';
	#请求方解密数据 公共iv
	public $public_iv = '2015031320180313';
	#接口请求域名
	#正式环境:v5.tuniaoapp.com; 测试环境:dev.tuniaoapp.com
	public $api_url = 'http://dev.tuniaoapp.com';

	public function __construct()
	{
		#iv,key补齐16位 用0填充
		$this->private_iv = $this->repairStrLength($this->private_iv);
		$this->private_key = $this->repairStrLength($this->private_key);
		$this->public_iv = $this->repairStrLength($this->public_iv);
		$this->public_key = $this->repairStrLength($this->public_key);
	}

	/**
	 * 获取费用详情demo
	 */
	public function checkTotlePrice()
	{
		$result_data = $this->getOrderPrice();
		die(json_encode($result_data));
	}

	private function getOrderPrice()
	{
		/*
		 * 利用私有key加密发送数据
		 */
		$timestamp = time();
		#密文格式:id+timestamp+key
		$encrypt_string = $this->partner_id . $timestamp . $this->private_key;
		#base64预先转码密文
		$encrypt_string = base64_encode($encrypt_string);
		#安全校验数据 AES-128-CBC方式加密密文
		$methods = openssl_get_cipher_methods();
		$sign = openssl_encrypt($encrypt_string, $methods[0], $this->private_key, 0, $this->private_iv);
		/**
		 * post方式发送请求到接口
		 */
		#计价接口
		$url = $this->api_url . '/v1/Order/checkTotlePrice';
		$post_data = [
			'id' => $this->partner_id,
			'timestamp' => $timestamp,
			'sign' => $sign,
			'car_id' => 22,
			'city_code' => 420502,
			'goodsid' => 49,
			'origin' => '111.328386000,30.712720000',
//			'destination' => '111.330049000,30.711528000', #单单传参
			'destination' => '["111.330049000,30.711528000","111.330049000,30.711528000"]',#多单传参
//			'lastest_time_m' => 60 * 55 #不传该字段为实时，传了为预约 值为时间差
		];
		$result = $this->curl_post_https($url, $post_data);
		/**
		 * 接收数据利用 公共key解密数据
		 */
		#安全校验数据 AES-128-CBC方式解密数据
		$result_data = openssl_decrypt($result, $methods[0], $this->public_key, 0, $this->public_iv);
		#base64转码获取json数据
		$result_data = base64_decode($result_data);
		#json_decode转码数据
		$result_data = json_decode($result_data, true);
		return $result_data;
	}

	/**
	 * 派单demo
	 */
	public function order()
	{
		#获取计价
		$result = $this->getOrderPrice();
		if ($result['Code'] != 1) {
			die($result['Message']);
		}
		$price_info = $result['Data'];
		/*
		 * 利用私有key加密发送数据
		 */
		$timestamp = time();
		#密文格式:id+timestamp+key
		$encrypt_string = $this->partner_id . $timestamp . $this->private_key;
		#base64预先转码密文
		$encrypt_string = base64_encode($encrypt_string);
		#安全校验数据 AES-128-CBC方式加密密文
		$methods = openssl_get_cipher_methods();
		$sign = openssl_encrypt($encrypt_string, $methods[0], $this->private_key, 0, $this->private_iv);
		/**
		 * post方式发送请求到接口
		 */
		$url = $this->api_url . '/v1/Order/order';
		#平台方自己生成的订单号 用于回调修改订单状态
		$orderno = md5(time());
		$post_data = [
			'id' => $this->partner_id,
			'timestamp' => $timestamp,
			'sign' => $sign,
			'car_id' => 22,
			'city_code' => 420502,
			'goods' => '美食',
			'goods_more' => '需要多辣',
			'goodsid' => $price_info['goods'],
			'origin' => '111.328386000,30.712720000',
			'laddr' => '西陵区东山康城',
			'phone' => '18500000000',
			'laddr_more' => '2-1601',
			'allmoney' => $price_info['allmoney'],
			'money_give' => $price_info['money_give'],
			'service_fee' => $price_info['service_fee'],
			'price_tianqi' => $price_info['price_tianqi'],
			'distance' => $price_info['distance'],
			'tagsaddprice' => $price_info['tagsaddprice'],
			'orderno' => $orderno,
//			'lastest_time_m' => $price_info['lastest_time_m'], #不传该字段为实时，传了为预约 值为时间差
//			'raddr' => '[{"addr1":"西陵区弘洋卢浮公馆(建设中)","addr2":"","lng":"111.330049000","lat":"30.711528000","city_code":"420502","phone":"18507100738"}]', #单单
			'raddr' => '[{"addr1":"西陵区弘洋卢浮公馆(建设中)","addr2":"","lng":"111.330049000","lat":"30.711528000","city_code":"420502","phone":"18507100738"},{"addr1":"西陵区弘洋卢浮公馆(建设中)","addr2":"","lng":"111.330049000","lat":"30.711528000","city_code":"420502","phone":"18507100738"}]',#多单
			'goods_value' => '炒饭炒面',
		];
		$result = $this->curl_post_https($url, $post_data);
		/**
		 * 接收数据利用 公共key解密数据
		 */
		#安全校验数据 AES-128-CBC方式解密数据
		$result_data = openssl_decrypt($result, $methods[0], $this->public_key, 0, $this->public_iv);
		#base64转码获取json数据
		$result_data = base64_decode($result_data);
		#json_decode转码数据
		$result_data = json_decode($result_data, true);
		die(json_encode($result_data));
	}

	/**
	 * 取消订单demo
	 */
	public function orderCancel()
	{
		/*
		 * 利用私有key加密发送数据
		 */
		$timestamp = time();
		#密文格式:id+timestamp+key
		$encrypt_string = $this->partner_id . $timestamp . $this->private_key;
		#base64预先转码密文
		$encrypt_string = base64_encode($encrypt_string);
		#安全校验数据 AES-128-CBC方式加密密文
		$methods = openssl_get_cipher_methods();
		$sign = openssl_encrypt($encrypt_string, $methods[0], $this->private_key, 0, $this->private_iv);
		/**
		 * post方式发送请求到接口
		 */
		#取消订单接口
		#平台方自己生成的订单号
		$orderno = md5(time());
		$url = $this->api_url . '/v1/Order/orderCancel';
		$post_data = [
			'id' => $this->partner_id,
			'timestamp' => $timestamp,
			'oid' => '784145',
			'orderno' => $orderno,
			'sign' => $sign,
		];
		$result = $this->curl_post_https($url, $post_data);
		/**
		 * 接收数据利用 公共key解密数据
		 */
		#安全校验数据 AES-128-CBC方式解密数据
		$result_data = openssl_decrypt($result, $methods[0], $this->public_key, 0, $this->public_iv);
		#base64转码获取json数据
		$result_data = base64_decode($result_data);
		#json_decode转码数据
		$result_data = json_decode($result_data, true);
		die(json_encode($result_data));
	}

	/**
	 * 查询账户余额demo
	 */
	public function myAccountInfo()
	{
		/*
		 * 利用私有key加密发送数据
		 */
		$timestamp = time();
		#密文格式:id+timestamp+key
		$encrypt_string = $this->partner_id . $timestamp . $this->private_key;
		#base64预先转码密文
		$encrypt_string = base64_encode($encrypt_string);
		#安全校验数据 AES-128-CBC方式加密密文
		$methods = openssl_get_cipher_methods();
		$sign = openssl_encrypt($encrypt_string, $methods[0], $this->private_key, 0, $this->private_iv);
		/**
		 * post方式发送请求到接口
		 */
		$url = $this->api_url . '/v1/Account/myAccountInfo';
		$post_data = [
			'id' => $this->partner_id,
			'timestamp' => $timestamp,
			'sign' => $sign,
		];
		$result = $this->curl_post_https($url, $post_data);
		/**
		 * 接收数据利用 公共key解密数据
		 */
		#安全校验数据 AES-128-CBC方式解密数据
		$result_data = openssl_decrypt($result, $methods[0], $this->public_key, 0, $this->public_iv);
		#base64转码获取json数据
		$result_data = base64_decode($result_data);
		#json_decode转码数据
		$result_data = json_decode($result_data, true);
		die(json_encode($result_data));
	}

	/**
	 * 模拟提交数据函数
	 */
	private function curl_post_https($url, $data)
	{
		// 模拟提交数据函数
		$curl = curl_init(); // 启动一个CURL会话
		curl_setopt($curl, CURLOPT_URL, $url); // 要访问的地址
		//curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0); // 对认证证书来源的检查
		//curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 1); // 从证书中检查SSL加密算法是否存在
		curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)'); // 模拟用户使用的浏览器
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1); // 使用自动跳转
		curl_setopt($curl, CURLOPT_AUTOREFERER, 1); // 自动设置Referer
		curl_setopt($curl, CURLOPT_POST, 1); // 发送一个常规的Post请求
		curl_setopt($curl, CURLOPT_POSTFIELDS, $data); // Post提交的数据包
		curl_setopt($curl, CURLOPT_TIMEOUT, 30); // 设置超时限制防止死循环
		curl_setopt($curl, CURLOPT_HEADER, 0); // 显示返回的Header区域内容
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1); // 获取的信息以文件流的形式返回
//		curl_setopt($curl, CURLOPT_PROXY, '127.0.0.1');
//		curl_setopt($curl, CURLOPT_PROXYPORT, '8888');
		$tmpInfo = curl_exec($curl); // 执行操作
		if (curl_errno($curl)) {
			echo 'Errno' . curl_error($curl);//捕抓异常
		}
		curl_close($curl); // 关闭CURL会话
		return $tmpInfo; // 返回数据，json格式
	}

	/**
	 * iv,key补齐16位 用0填充
	 * @param $str
	 * @return string
	 */
	private function repairStrLength($str)
	{
		if (strlen($str) < 16) {
			$add = '';
			for ($i = 0; $i < (16 - strlen($str)); $i++) {
				$add .= '0';
			}
			$str .= $add;
		}
		return $str;
	}
}